<?
// V1.00	09.04.2013 - Erstes Release

// Dieses Skript erzeugt automatisch aus dem IEC 62056-21 Protokoll Datenstrom die
// entsprechenden Variablen um sie in IPSymcon zu visualisieren.
//
//  © by Kevin Heidrich 2013
//			kevinheidrich@me.com
//  Web: www.kh-solutions.de

// Vorgehensweise:

//[]-Kategorie
//  |- Skript
//  |- Register Variable

// 1. Dieses Skript in eine Kategorie legen.
// 2. Eine IO Instanz für die entsprechende Datenquelle (z.B. Serial Port) anlegen
// 3. Einen Cutter anlegen mit "Linkes Trennzeichen -> /ESY" und "Rechtes Trennzeichen -> !". Übergeordnete Instanz natürlich die IO Datenquelle
// 4. Eine Register Variable anlegen mit dem Cutter als übergeordneten Instanz, und diesem Skript als Ziel ID
//
// Nun werden alle erkannten Variablen automatisch in dieser Kategorie angelegt.
// Abhängig vom Datenstrom kann dies ein wenig dauern.

	  
// Das Skript sollte in einem Container sein - Wird aber nicht geprüft
	$parentID = IPS_GetParent($_IPS['SELF']);

// Die Variablen die in dem eHZ Datenpaket erkannt werden, werden mit einem Präfix versehen
	$namePraefix = "eHZ_";
// Der aktuelle Wert der Variable die aufsummiert werden sollen, wird mit einem suffix versehen
	$tempSuffix = "_temp";
// Der aktuelle Interval der Variable
	$counterSuffix = "_counter";

// code -> Wie sieht der String aus, der für dieses Wert passen soll. (Kann auch ein Auszug aus dem Gesamtstring sein!)
// name -> Unter diesem Namen wird eine Variable im IPS angelegt. Inkl. Prä+Suffix
// interval -> Alle n Datenpakete wird diese Zeile in die Zählvariable übernommen. (-1 = einmalig beim Start speichern!)
// sum -> Soll diese Variable aufsummiert werden? Das ist nur in Verbindung mit interval > 1 sinnvoll!

// Zusätzliche Einträge sind ohne weitere Änderungen im Code möglich. Ich habe die letzten Stellen .. x*255 entfernt, damit nicht
// mehrere unnötige Einträge erstellt werden müssen, und es so für einen größeren Teil der Leute funktioniert.

	$eHZVariableList = array(
						array("code" => "0-0:96.1",	"name" => "Fabriknummer",					"interval" => -1, "sum" => true),
						array("code" => "1-0:0.0",		"name" => "Eigentumsnummer",				"interval" => -1, "sum" => false),
						
						array("code" => "1-0:1.7",		"name" => "Leistung Summe",				"interval" => 30, "sum" => true),
						array("code" => "1-0:1.8",		"name" => "Zaehlerstand Bezug",			"interval" => 30, "sum" => false),
						array("code" => "1-0:2.8",		"name" => "Zaehlerstand Lieferung",		"interval" => 30, "sum" => false),

						array("code" => "1-0:21.7",	"name" => "Leistung L1",					"interval" => 30, "sum" => true),
						array("code" => "1-0:31.7",	"name" => "Strom L1",						"interval" => 30, "sum" => true),
						array("code" => "1-0:32.7",	"name" => "Spannung L1",					"interval" => 30, "sum" => true),

						array("code" => "1-0:41.7",	"name" => "Leistung L2",					"interval" => 30, "sum" => true),
						array("code" => "1-0:51.7",	"name" => "Strom L2",						"interval" => 30, "sum" => true),
						array("code" => "1-0:52.7",	"name" => "Spannung L2",					"interval" => 30, "sum" => true),

						array("code" => "1-0:61.7",	"name" => "Leistung L3",					"interval" => 30, "sum" => true),
						array("code" => "1-0:71.7",	"name" => "Strom L3",						"interval" => 30, "sum" => true),
						array("code" => "1-0:72.7",	"name" => "Spannung L3",					"interval" => 30, "sum" => true),

						array("code" => "1-0:96.5",	"name" => "Status",							"interval" =>  1, "sum" => false)
						);


	$stringList = explode( "\n", trim($_IPS['VALUE']) );

	foreach($stringList as $string)
	{
		// Liste der eHZ Variablen durchgehen und entsprechend handeln
		foreach($eHZVariableList as $eHZVariable)
		{
			// Ist der Code in der Zeile vorhanden?
			if (strstr($string,$eHZVariable["code"]))
			{
				$varValue = $namePraefix.$eHZVariable["name"];
				$varTemp = $varValue.$tempSuffix;
				$varCounter = $varValue.$counterSuffix;

				// Value aus Datenstrom ziehen
				$value = "hahn";
				preg_match('/.*\(((.*)\*(.*)|(.*))\)/',$string,$result);
				
			   $unit = $result[3];

				// Value hat ne Einheit
				if ($unit != "")
				{
				   $value = floatval($result[2]);
				   
				   $varProfilName = $namePraefix."Profil_".$unit;
				   
				   // Evtl. ein Variablenprofil anlegen
				   if (!IPS_VariableProfileExists($varProfilName))
					{
					   IPS_CreateVariableProfile($varProfilName,2);
					   IPS_SetVariableProfileText($varProfilName,""," ".$unit);
					}
				}
				else
				{
				   $value = $result[4];
				   $varProfilName = "";
				}

				// Nur 1 mal speichern
				if ($eHZVariable["interval"] == -1)
				{
				 	if (getVariable($parentID,$varTemp) == false)
				 	{
						setVariable($parentID,$varValue,$value,$varProfilName);
						setVariable($parentID,$varTemp,true);
					}
					
					continue;
				}

				// Nicht aufsummieren .. trotzdem gibt es einen Counter, der nur alle x Datenpakete übernimmt.
				if ($eHZVariable["sum"] == false)
				{
					$actualCounter = getVariable($parentID,$varCounter);

					// Counter Variable noch gar nicht gesetzt, Wert abspeichern
					if ($actualCounter === false)
					{
						setVariable($parentID,$varCounter,0);
						setVariable($parentID,$varValue,$value,$varProfilName);
					}
					else
					{
						// Interval Grenze erreicht.. Wert abspeichern
						if ($actualCounter >= $eHZVariable["interval"])
						{
							setVariable($parentID,$varValue,$value,$varProfilName);
							$actualCounter = 0;
						}

						$actualCounter ++;
						// Counter aktualisieren
						setVariable($parentID,$varCounter,$actualCounter);
					}

				}
				// Aufsummieren
				else
				{
					$actualCounter = getVariable($parentID,$varCounter);
					$actualTemp = getVariable($parentID,$varTemp);

					// Counter Variable noch gar nicht gesetzt, Wert abspeichern
					if ($actualCounter === null)
					{
						setVariable($parentID,$varCounter,0);
						setVariable($parentID,$varValue,$value,$varProfilName);
						setVariable($parentID,$varTemp,0.0);
					}
					else
					{
						// Interval Grenze erreicht.. Wert abspeichern
						if ($actualCounter >= $eHZVariable["interval"])
						{
							setVariable($parentID,$varTemp,$value);
							setVariable($parentID,$varValue,round(($actualTemp / $actualCounter),2),$varProfilName);
							$actualCounter = 0;
							setVariable($parentID,$varCounter,$actualCounter);
						}
						else
						{
							setVariable($parentID,$varTemp,$actualTemp+$value);
						}

						$actualCounter ++;
						// Counter aktualisieren
						setVariable($parentID,$varCounter,$actualCounter);

					}
				}
			}
		}
	}

// -----------------------------------------------------------------------------
// Zusatzfunktionen
// -----------------------------------------------------------------------------

function setVariable($parentID,$varName,$value,$profilName="")
{
	// Variable nicht vorhanden
	if(!$varID=@IPS_GetVariableIDByName($varName,$parentID))
	{
		// Variable vom Typ erzeugen
		if (is_bool($value))
			$varID=IPS_CreateVariable(0);
		else if (is_int($value))
			$varID=IPS_CreateVariable(1);
		else if (is_float($value))
			$varID=IPS_CreateVariable(2);
		else if (is_string($value))
			$varID=IPS_CreateVariable(3);
		else
		   return;

		IPS_SetName($varID, $varName);
		IPS_SetParent($varID,$parentID);
		if ($profilName != "")
			IPS_SetVariableCustomProfile($varID,$profilName);
	}

	SetValue($varID,$value);
}

function getVariable($parentID,$varName)
{
	// Variable vorhanden
	if($varID=@IPS_GetVariableIDByName($varName,$parentID))
	{
		return GetValue($varID);
	}

	return null;
}


?>